/**
 * 
 * SOME COPYRIGHT
 * 
 * RoutingDomainDropCounter.hpp
 * 
 * generated RoutingDomainDropCounter.hpp file genie code generation framework free of license.
 *  
 */
#pragma once
#ifndef GI_GBPE_ROUTINGDOMAINDROPCOUNTER_HPP
#define GI_GBPE_ROUTINGDOMAINDROPCOUNTER_HPP

#include <boost/optional.hpp>
#include "opflex/modb/URIBuilder.h"
#include "opflex/modb/mo-internal/MO.h"

namespace modelgbp {
namespace gbpe {

class RoutingDomainDropCounter
    : public opflex::modb::mointernal::MO
{
public:

    /**
     * The unique class ID for RoutingDomainDropCounter
     */
    static const opflex::modb::class_id_t CLASS_ID = 50;

    /**
     * Check whether bytes has been set
     * @return true if bytes has been set
     */
    bool isBytesSet()
    {
        return getObjectInstance().isSet(1638405ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of bytes if it has been set.
     * @return the value of bytes or boost::none if not set
     */
    boost::optional<uint64_t> getBytes()
    {
        if (isBytesSet())
            return getObjectInstance().getUInt64(1638405ul);
        return boost::none;
    }

    /**
     * Get the value of bytes if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of bytes if set, otherwise the value of default passed in
     */
    uint64_t getBytes(uint64_t defaultValue)
    {
        return getBytes().get_value_or(defaultValue);
    }

    /**
     * Set bytes to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::RoutingDomainDropCounter& setBytes(uint64_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(1638405ul, newValue);
        return *this;
    }

    /**
     * Unset bytes in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::RoutingDomainDropCounter& unsetBytes()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1638405ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether genId has been set
     * @return true if genId has been set
     */
    bool isGenIdSet()
    {
        return getObjectInstance().isSet(1638402ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of genId if it has been set.
     * @return the value of genId or boost::none if not set
     */
    boost::optional<uint64_t> getGenId()
    {
        if (isGenIdSet())
            return getObjectInstance().getUInt64(1638402ul);
        return boost::none;
    }

    /**
     * Get the value of genId if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of genId if set, otherwise the value of default passed in
     */
    uint64_t getGenId(uint64_t defaultValue)
    {
        return getGenId().get_value_or(defaultValue);
    }

    /**
     * Set genId to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::RoutingDomainDropCounter& setGenId(uint64_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(1638402ul, newValue);
        return *this;
    }

    /**
     * Unset genId in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::RoutingDomainDropCounter& unsetGenId()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1638402ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether packets has been set
     * @return true if packets has been set
     */
    bool isPacketsSet()
    {
        return getObjectInstance().isSet(1638404ul, opflex::modb::PropertyInfo::U64);
    }

    /**
     * Get the value of packets if it has been set.
     * @return the value of packets or boost::none if not set
     */
    boost::optional<uint64_t> getPackets()
    {
        if (isPacketsSet())
            return getObjectInstance().getUInt64(1638404ul);
        return boost::none;
    }

    /**
     * Get the value of packets if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of packets if set, otherwise the value of default passed in
     */
    uint64_t getPackets(uint64_t defaultValue)
    {
        return getPackets().get_value_or(defaultValue);
    }

    /**
     * Set packets to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::RoutingDomainDropCounter& setPackets(uint64_t newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setUInt64(1638404ul, newValue);
        return *this;
    }

    /**
     * Unset packets in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::RoutingDomainDropCounter& unsetPackets()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1638404ul, opflex::modb::PropertyInfo::U64, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether routingDomain has been set
     * @return true if routingDomain has been set
     */
    bool isRoutingDomainSet()
    {
        return getObjectInstance().isSet(1638403ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of routingDomain if it has been set.
     * @return the value of routingDomain or boost::none if not set
     */
    boost::optional<const std::string&> getRoutingDomain()
    {
        if (isRoutingDomainSet())
            return getObjectInstance().getString(1638403ul);
        return boost::none;
    }

    /**
     * Get the value of routingDomain if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of routingDomain if set, otherwise the value of default passed in
     */
    const std::string& getRoutingDomain(const std::string& defaultValue)
    {
        return getRoutingDomain().get_value_or(defaultValue);
    }

    /**
     * Set routingDomain to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::RoutingDomainDropCounter& setRoutingDomain(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(1638403ul, newValue);
        return *this;
    }

    /**
     * Unset routingDomain in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::RoutingDomainDropCounter& unsetRoutingDomain()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1638403ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Check whether uuid has been set
     * @return true if uuid has been set
     */
    bool isUuidSet()
    {
        return getObjectInstance().isSet(1638401ul, opflex::modb::PropertyInfo::STRING);
    }

    /**
     * Get the value of uuid if it has been set.
     * @return the value of uuid or boost::none if not set
     */
    boost::optional<const std::string&> getUuid()
    {
        if (isUuidSet())
            return getObjectInstance().getString(1638401ul);
        return boost::none;
    }

    /**
     * Get the value of uuid if set, otherwise the value of default passed in.
     * @param defaultValue default value returned if the property is not set
     * @return the value of uuid if set, otherwise the value of default passed in
     */
    const std::string& getUuid(const std::string& defaultValue)
    {
        return getUuid().get_value_or(defaultValue);
    }

    /**
     * Set uuid to the specified value in the currently-active mutator.
     * 
     * @param newValue the new value to set.
     * @return a reference to the current object
     * @throws std::logic_error if no mutator is active
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::RoutingDomainDropCounter& setUuid(const std::string& newValue)
    {
        getTLMutator().modify(getClassId(), getURI())->setString(1638401ul, newValue);
        return *this;
    }

    /**
     * Unset uuid in the currently-active mutator.
     * @throws std::logic_error if no mutator is active
     * @return a reference to the current object
     * @see opflex::modb::Mutator
     */
    modelgbp::gbpe::RoutingDomainDropCounter& unsetUuid()
    {
        getTLMutator().modify(getClassId(), getURI())->unset(1638401ul, opflex::modb::PropertyInfo::STRING, opflex::modb::PropertyInfo::SCALAR);
        return *this;
    }

    /**
     * Retrieve an instance of RoutingDomainDropCounter from the managed
     * object store.  If the object does not exist in the local store,
     * returns boost::none.  Note that even though it may not exist
     * locally, it may still exist remotely.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::RoutingDomainDropCounter> > resolve(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::gbpe::RoutingDomainDropCounter>(framework, CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of RoutingDomainDropCounter from the managed
     * object store using the default framework instance.  If the 
     * object does not exist in the local store, returns boost::none. 
     * Note that even though it may not exist locally, it may still 
     * exist remotely.
     * 
     * @param uri the URI of the object to retrieve
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::RoutingDomainDropCounter> > resolve(
        const opflex::modb::URI& uri)
    {
        return opflex::modb::mointernal::MO::resolve<modelgbp::gbpe::RoutingDomainDropCounter>(opflex::ofcore::OFFramework::defaultInstance(), CLASS_ID, uri);
    }

    /**
     * Retrieve an instance of RoutingDomainDropCounter from the managed
     * object store by constructing its URI from the path elements
     * that lead to it.  If the object does not exist in the local
     * store, returns boost::none.  Note that even though it may not
     * exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /ObserverPolicyStatUniverse/GbpeRoutingDomainDropCounter/[gbpeRoutingDomainDropCounterUuid]/[gbpeRoutingDomainDropCounterGenId]/[gbpeRoutingDomainDropCounterRoutingDomain]
     * 
     * @param framework the framework instance to use 
     * @param gbpeRoutingDomainDropCounterUuid the value of gbpeRoutingDomainDropCounterUuid,
     * a naming property for RoutingDomainDropCounter
     * @param gbpeRoutingDomainDropCounterGenId the value of gbpeRoutingDomainDropCounterGenId,
     * a naming property for RoutingDomainDropCounter
     * @param gbpeRoutingDomainDropCounterRoutingDomain the value of gbpeRoutingDomainDropCounterRoutingDomain,
     * a naming property for RoutingDomainDropCounter
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::RoutingDomainDropCounter> > resolve(
        opflex::ofcore::OFFramework& framework,
        const std::string& gbpeRoutingDomainDropCounterUuid,
        uint64_t gbpeRoutingDomainDropCounterGenId,
        const std::string& gbpeRoutingDomainDropCounterRoutingDomain)
    {
        return resolve(framework,opflex::modb::URIBuilder().addElement("ObserverPolicyStatUniverse").addElement("GbpeRoutingDomainDropCounter").addElement(gbpeRoutingDomainDropCounterUuid).addElement(gbpeRoutingDomainDropCounterGenId).addElement(gbpeRoutingDomainDropCounterRoutingDomain).build());
    }

    /**
     * Retrieve an instance of RoutingDomainDropCounter from the 
     * default managed object store by constructing its URI from the
     * path elements that lead to it.  If the object does not exist in
     * the local store, returns boost::none.  Note that even though it
     * may not exist locally, it may still exist remotely.
     * 
     * The object URI generated by this function will take the form:
     * /ObserverPolicyStatUniverse/GbpeRoutingDomainDropCounter/[gbpeRoutingDomainDropCounterUuid]/[gbpeRoutingDomainDropCounterGenId]/[gbpeRoutingDomainDropCounterRoutingDomain]
     * 
     * @param gbpeRoutingDomainDropCounterUuid the value of gbpeRoutingDomainDropCounterUuid,
     * a naming property for RoutingDomainDropCounter
     * @param gbpeRoutingDomainDropCounterGenId the value of gbpeRoutingDomainDropCounterGenId,
     * a naming property for RoutingDomainDropCounter
     * @param gbpeRoutingDomainDropCounterRoutingDomain the value of gbpeRoutingDomainDropCounterRoutingDomain,
     * a naming property for RoutingDomainDropCounter
     * @return a shared pointer to the object or boost::none if it
     * does not exist.
     */
    static boost::optional<OF_SHARED_PTR<modelgbp::gbpe::RoutingDomainDropCounter> > resolve(
        const std::string& gbpeRoutingDomainDropCounterUuid,
        uint64_t gbpeRoutingDomainDropCounterGenId,
        const std::string& gbpeRoutingDomainDropCounterRoutingDomain)
    {
        return resolve(opflex::ofcore::OFFramework::defaultInstance(),gbpeRoutingDomainDropCounterUuid,gbpeRoutingDomainDropCounterGenId,gbpeRoutingDomainDropCounterRoutingDomain);
    }

    /**
     * Remove this instance using the currently-active mutator.  If
     * the object does not exist, then this will be a no-op.  If this
     * object has any children, they will be garbage-collected at some
     * future time.
     * 
     * @throws std::logic_error if no mutator is active
     */
    void remove()
    {
        getTLMutator().remove(CLASS_ID, getURI());
    }

    /**
     * Remove the RoutingDomainDropCounter object with the specified URI
     * using the currently-active mutator.  If the object does not exist,
     * then this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * @param framework the framework instance to use
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(opflex::ofcore::OFFramework& framework,
                       const opflex::modb::URI& uri)
    {
        MO::remove(framework, CLASS_ID, uri);
    }

    /**
     * Remove the RoutingDomainDropCounter object with the specified URI 
     * using the currently-active mutator and the default framework 
     * instance.  If the object does not exist, then this will be a
     * no-op.  If this object has any children, they will be 
     * garbage-collected at some future time.
     * 
     * @param uri the URI of the object to remove
     * @throws std::logic_error if no mutator is active
     */
    static void remove(const opflex::modb::URI& uri)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(), uri);
    }

    /**
     * Remove the RoutingDomainDropCounter object with the specified path
     * elements from the managed object store.  If the object does
     * not exist, then this will be a no-op.  If this object has any
     * children, they will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /ObserverPolicyStatUniverse/GbpeRoutingDomainDropCounter/[gbpeRoutingDomainDropCounterUuid]/[gbpeRoutingDomainDropCounterGenId]/[gbpeRoutingDomainDropCounterRoutingDomain]
     * 
     * @param framework the framework instance to use
     * @param gbpeRoutingDomainDropCounterUuid the value of gbpeRoutingDomainDropCounterUuid,
     * a naming property for RoutingDomainDropCounter
     * @param gbpeRoutingDomainDropCounterGenId the value of gbpeRoutingDomainDropCounterGenId,
     * a naming property for RoutingDomainDropCounter
     * @param gbpeRoutingDomainDropCounterRoutingDomain the value of gbpeRoutingDomainDropCounterRoutingDomain,
     * a naming property for RoutingDomainDropCounter
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        opflex::ofcore::OFFramework& framework,
        const std::string& gbpeRoutingDomainDropCounterUuid,
        uint64_t gbpeRoutingDomainDropCounterGenId,
        const std::string& gbpeRoutingDomainDropCounterRoutingDomain)
    {
        MO::remove(framework, CLASS_ID, opflex::modb::URIBuilder().addElement("ObserverPolicyStatUniverse").addElement("GbpeRoutingDomainDropCounter").addElement(gbpeRoutingDomainDropCounterUuid).addElement(gbpeRoutingDomainDropCounterGenId).addElement(gbpeRoutingDomainDropCounterRoutingDomain).build());
    }

    /**
     * Remove the RoutingDomainDropCounter object with the specified path
     * elements from the managed object store using the default
     * framework instance.  If the object does not exist, then
     * this will be a no-op.  If this object has any children, they
     * will be garbage-collected at some future time.
     * 
     * The object URI generated by this function will take the form:
     * /ObserverPolicyStatUniverse/GbpeRoutingDomainDropCounter/[gbpeRoutingDomainDropCounterUuid]/[gbpeRoutingDomainDropCounterGenId]/[gbpeRoutingDomainDropCounterRoutingDomain]
     * 
     * @param gbpeRoutingDomainDropCounterUuid the value of gbpeRoutingDomainDropCounterUuid,
     * a naming property for RoutingDomainDropCounter
     * @param gbpeRoutingDomainDropCounterGenId the value of gbpeRoutingDomainDropCounterGenId,
     * a naming property for RoutingDomainDropCounter
     * @param gbpeRoutingDomainDropCounterRoutingDomain the value of gbpeRoutingDomainDropCounterRoutingDomain,
     * a naming property for RoutingDomainDropCounter
     * @throws std::logic_error if no mutator is active
     */
    static void remove(
        const std::string& gbpeRoutingDomainDropCounterUuid,
        uint64_t gbpeRoutingDomainDropCounterGenId,
        const std::string& gbpeRoutingDomainDropCounterRoutingDomain)
    {
        remove(opflex::ofcore::OFFramework::defaultInstance(),gbpeRoutingDomainDropCounterUuid,gbpeRoutingDomainDropCounterGenId,gbpeRoutingDomainDropCounterRoutingDomain);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class.  This listener will be called for any modifications
     * of this class or any transitive children of this class.
     * 
     * @param framework the framework instance 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::registerListener(framework, listener, CLASS_ID);
    }

    /**
     * Register a listener that will get called for changes related to
     * this class with the default framework instance.  This listener
     * will be called for any modifications of this class or any
     * transitive children of this class.
     * 
     * @param listener the listener functional object that should be
     * called when changes occur related to the class.  This memory is
     * owned by the caller and should be freed only after it has been
     * unregistered.
     */
    static void registerListener(
        opflex::modb::ObjectListener* listener)
    {
        registerListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Unregister a listener from updates to this class.
     * 
     * @param framework the framework instance 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::ofcore::OFFramework& framework,
        opflex::modb::ObjectListener* listener)
    {
        opflex::modb::mointernal
            ::MO::unregisterListener(framework, listener, CLASS_ID);
    }

    /**
     * Unregister a listener from updates to this class from the
     * default framework instance
     * 
     * @param listener The listener to unregister.
     */
    static void unregisterListener(
        opflex::modb::ObjectListener* listener)
    {
        unregisterListener(opflex::ofcore::OFFramework::defaultInstance(), listener);
    }

    /**
     * Construct an instance of RoutingDomainDropCounter.
     * This should not typically be called from user code.
     */
    RoutingDomainDropCounter(
        opflex::ofcore::OFFramework& framework,
        const opflex::modb::URI& uri,
        const OF_SHARED_PTR<const opflex::modb::mointernal::ObjectInstance>& oi)
        : MO(framework, CLASS_ID, uri, oi) { }
}; // class RoutingDomainDropCounter

} // namespace gbpe
} // namespace modelgbp
#endif // GI_GBPE_ROUTINGDOMAINDROPCOUNTER_HPP
